/*
   Libre Media Server - A Media Server Sotfware for stage and performing
   Copyright (C) 2012-2013  Santiago Noreña libremediaserver@gmail.com

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef LIBREMEDIASERVER_H
#define LIBREMEDIASERVER_H

#include <QMainWindow>
//#include <QApplication>
#include <QObject>
#include <QDesktopWidget>
#include <QtGui>

#include <QFile>
#include <QFileInfo>
#include <QFileDialog>
#include <QTextStream>
#include <QWebView>
#include <QUrl>
#include <QVBoxLayout>
#include <QTextEdit>

#include "settings.h"
#include "audiomotor.h"
#include "olathread.h"
#include "audiolayerwidget.h"
#include "audiomasterwidget.h"
#include "audiowidget.h"

#include "ui_libremediaserver-audio.h"

#define VERSION "LibreMediaServer-Audio Version 0.1.0"
#define COPYRIGHT "(C) 2014 Santi Norena libremediaserver@gmail.com"
#define LICENSE "GPL 3 License. See LICENSE.txt and credits.txt for details"

class QMenu;
//class QProcess;

class libreMediaServerAudio : public QMainWindow
{
    Q_OBJECT

public:

    libreMediaServerAudio (QStringList args, QWidget *parent = 0);
    virtual ~libreMediaServerAudio();

    Ui::LibreMediaServerAudio ui;

protected:

    QString m_pathmedia; // Path to Medias
    QProcess *m_ola; // OLA daemon process

    bool m_gui;

private:

   QTextEdit *textEdit; // Terminal de feedback
   AudioMasterWidget *amw;
//   AudioLayerWidget *alw;
   AudioWidget *aw;

   olaThread *ola;

    void open_start();
    void save_finish();
    void open(QFile *file);
    void save(QFile *file);

//   void MessageHandler(QtMsgType type, const char *msg);

public slots:

    inline void toTerminal (QString message)
    {
        textEdit->append(message);
    }

private slots:

    /**
     * @brief loadbang The audio motor engine is setup. Resend the dmx info to maintain aupdated to the current state
     */

    void loadbang();

    void olasetup();

    void dmxInput(int layer, int channel, int value);

    // Menu File
    void openFile();
    void saveFile();
    void ChangeMediaPath();// Change the path to medias

};

#endif // LIBREMEDIASERVER_H
